BuildRequires: ant-optional
BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


Name:           checkstyle
Version:        4.1
Release:        alt2_3jpp1.7
Epoch:          0
Summary:        Java source code checker
License:        LGPL
Group:          Development/Java
Source0:        http://download.sf.net/checkstyle/checkstyle-src-4.1.tar.gz
Source1:        %{name}-%{version}-script
Source2:        %{name}-%{version}.catalog

Patch0:		%{name}-%{version}-build.patch
Patch1:         %{name}-%{version}-javadoc-crosslink.patch

Patch2:		%{name}-%{version}-checks-AllTests.patch
Patch3:		%{name}-%{version}-checks-blocks-AllTests.patch
Patch4:		%{name}-%{version}-checks-coding-AllTests.patch
Patch5:		%{name}-%{version}-checks-design-AllTests.patch
Patch6:		%{name}-%{version}-checks-imports-AllTests.patch
Patch7:		%{name}-%{version}-checks-indentation-AllTests.patch
Patch8:		%{name}-%{version}-checks-javadoc-AllTests.patch
Patch9:		%{name}-%{version}-checks-metrics-AllTests.patch
Patch10:	%{name}-%{version}-checks-modifier-AllTests.patch
Patch11:	%{name}-%{version}-checks-naming-AllTests.patch
Patch12:	%{name}-%{version}-checks-sizes-AllTests.patch
Patch13:	%{name}-%{version}-checks-whitespace-AllTests.patch
Patch14:	%{name}-%{version}-grammars-AllTests.patch

URL:            http://checkstyle.sourceforge.net/
Requires: ant >= 0:1.6
Requires: antlr >= 0:2.7.1 regexp >= 0:1.2 jakarta-commons-logging
Requires: jakarta-commons-cli jakarta-commons-beanutils
Requires: jakarta-commons-collections jpackage-utils >= 0:1.5
Requires: jaxp_parser_impl
BuildRequires: ant >= 0:1.6 ant-nodeps >= 0:1.6
BuildRequires: ant-junit >= 0:1.6 junit antlr >= 0:2.7.1
BuildRequires: java-devel < 0:1.5.0
BuildRequires: jakarta-commons-beanutils
BuildRequires: jakarta-commons-cli-1 xalan-j2 jpackage-utils >= 0:1.5
# xerces-j2 because tests fail with gnujaxp...
BuildRequires: jakarta-commons-logging jakarta-commons-collections xerces-j2
BuildRequires: antlr-javadoc xml-commons-apis-javadoc
BuildRequires: jakarta-commons-beanutils-javadoc ant-javadoc /usr/bin/perl
BuildRequires: excalibur-avalon-logkit
BuildRequires: emma
BuildRequires: jdom
BuildRequires: velocity
BuildArch:      noarch

%description
A tool for checking Java source code for adherence to a set of rules.

%package        demo
Group:          Development/Java
Summary:        Demos for %{name}
Requires: %{name} = %{epoch}:%{version}

%description    demo
Demonstrations and samples for %{name}.

%package        javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description    javadoc
Javadoc for %{name}.

%package        manual
Group:          Development/Java
Summary:        Manual for %{name}

%description    manual
Manual for %{name}.

%package        optional
Group:          Development/Java
Summary:        Optional functionality for %{name}
Requires: %{name} = %{epoch}:%{version}

%description    optional
Optional functionality for %{name}.

%prep
%setup -q -n %{name}-src-%{version}
%patch0 -b .sav
#%patch1 -p0
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -b .sav
%patch9 -b .sav
%patch10 -b .sav
%patch11 -b .sav
%patch12 -b .sav
%patch13 -b .sav
%patch14 -b .sav
%__perl -p -i -e 's|\./{\@docRoot}/\.\./index\.html|%{_docdir}/%{name}-manual-%{version}/index.html|' build.xml
# remove all binary libs
find . -name "*.jar" -exec %__rm -f {} \;
# some testinputs require java-1.5
pushd src/testinputs
rm \
com/puppycrawl/tools/checkstyle/coding/InputDeclarationOrder.java \
com/puppycrawl/tools/checkstyle/coding/InputDefaultComesLast.java \
com/puppycrawl/tools/checkstyle/coding/InputExplicitInit.java \
com/puppycrawl/tools/checkstyle/coding/InputFinalize.java \
com/puppycrawl/tools/checkstyle/coding/InputFinalLocalVariable.java \
com/puppycrawl/tools/checkstyle/coding/InputInnerAssignment.java \
com/puppycrawl/tools/checkstyle/coding/InputModifiedControl.java \
com/puppycrawl/tools/checkstyle/coding/InputRequireThis.java \
com/puppycrawl/tools/checkstyle/coding/InputUnnecessaryParentheses.java \
com/puppycrawl/tools/checkstyle/Input15Extensions.java \
com/puppycrawl/tools/checkstyle/InputDesignForExtension.java \
com/puppycrawl/tools/checkstyle/InputFinalClass.java \
com/puppycrawl/tools/checkstyle/InputFinalParameters.java \
com/puppycrawl/tools/checkstyle/InputGenerics.java \
com/puppycrawl/tools/checkstyle/InputHiddenField.java \
com/puppycrawl/tools/checkstyle/InputHiddenFieldReorder.java \
com/puppycrawl/tools/checkstyle/InputInner.java \
com/puppycrawl/tools/checkstyle/InputJavadoc.java \
com/puppycrawl/tools/checkstyle/InputJavadocStyleCheck.java \
com/puppycrawl/tools/checkstyle/InputLeftCurlyMethod.java \
com/puppycrawl/tools/checkstyle/InputLeftCurlyOther.java \
com/puppycrawl/tools/checkstyle/InputMagicNumber.java \
com/puppycrawl/tools/checkstyle/InputModifier.java \
com/puppycrawl/tools/checkstyle/InputOpWrap.java \
com/puppycrawl/tools/checkstyle/InputScopeInnerInterfaces.java \
com/puppycrawl/tools/checkstyle/InputSemantic.java \
com/puppycrawl/tools/checkstyle/InputTags.java \
com/puppycrawl/tools/checkstyle/InputTypeParamsTags.java \
com/puppycrawl/tools/checkstyle/InputWhitespace.java \
com/puppycrawl/tools/checkstyle/MyAnnotation.java \
com/puppycrawl/tools/checkstyle/grammars/InputHexFloat.java \
com/puppycrawl/tools/checkstyle/grammars/InputVararg.java \
com/puppycrawl/tools/checkstyle/imports/InputImportControl.java \
com/puppycrawl/tools/checkstyle/imports/InputImportOrderCaseInsensitive.java \
com/puppycrawl/tools/checkstyle/imports/InputImportOrder.java \
com/puppycrawl/tools/checkstyle/indentation/InputValidBlockIndent.java \
com/puppycrawl/tools/checkstyle/indentation/InputValidClassDefIndent.java \
com/puppycrawl/tools/checkstyle/indentation/InputValidForIndent.java \
com/puppycrawl/tools/checkstyle/javadoc/TestGenerics.java \
com/puppycrawl/tools/checkstyle/metrics/ClassCouplingCheckTestInput.java \
com/puppycrawl/tools/checkstyle/package-info.java \
com/puppycrawl/tools/checkstyle/whitespace/InputMethodParamPad.java \
com/puppycrawl/tools/checkstyle/indentation/InputValidAssignIndent.java \
com/puppycrawl/tools/checkstyle/InputDoubleCheckedLocking.java \

popd
pushd src/tests
rm \
com/puppycrawl/tools/checkstyle/checks/FinalParametersCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/GenericIllegalRegexpCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/RegexpCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/RequiredRegexpCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/UpperEllCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/blocks/EmptyBlockCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/blocks/LeftCurlyCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/blocks/RightCurlyCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/AvoidInlineConditionalsCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/DeclarationOrderCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/DefaultComesLastCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/DoubleCheckedLockingCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/EqualsHashCodeCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/ExplicitInitializationCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/FinalLocalVariableCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/HiddenFieldCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/IllegalInstantiationCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/InnerAssignmentCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/MagicNumberCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/ModifiedControlVariableCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/RedundantThrowsCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/RequireThisCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/SuperFinalizeCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/coding/UnnecessaryParenthesesCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/design/DesignForExtensionCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/design/FinalClassCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/design/HideUtilityClassConstructorCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/design/VisibilityModifierCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/imports/ImportControlCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/imports/ImportOrderCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/imports/UnusedImportsCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/indentation/IndentationCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/javadoc/JavadocMethodCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/javadoc/JavadocStyleCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/javadoc/JavadocTypeCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/javadoc/JavadocVariableCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/metrics/ClassDataAbstractionCouplingCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/metrics/ClassFanOutComplexityCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/modifier/ModifierOrderCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/modifier/RedundantModifierTest.java \
com/puppycrawl/tools/checkstyle/checks/naming/ConstantNameCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/naming/LocalFinalVariableNameCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/naming/LocalVariableNameCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/naming/MemberNameCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/naming/ParameterNameCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/sizes/MethodLengthCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/whitespace/MethodParamPadCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/whitespace/NoWhitespaceAfterCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/whitespace/NoWhitespaceBeforeCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/whitespace/OperatorWrapCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/whitespace/ParenPadCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/whitespace/TypecastParenPadCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/whitespace/WhitespaceAfterCheckTest.java \
com/puppycrawl/tools/checkstyle/checks/whitespace/WhitespaceAroundTest.java \
com/puppycrawl/tools/checkstyle/grammars/HexFloatsTest.java \
com/puppycrawl/tools/checkstyle/grammars/VarargTest.java \

popd

%build
export JAVA_HOME=/usr/lib/jvm/java-1.4.2
export OPT_JAR_LIST="ant/ant-junit junit ant/ant-nodeps jdom velocity"
export CLASSPATH=$(build-classpath excalibur/avalon-logkit commons-collections velocity jdom)

pushd lib
ln -sf $(build-classpath antlr) .
ln -sf $(build-classpath commons-beanutils-core) .
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-cli) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath emma) .
ln -sf $(build-classpath emma_ant) .
popd

%ant \
  -Dbuild.sysclasspath=first \
  -Dant.javadoc=%{_javadocdir}/ant \
  -Dantlr.javadoc=%{_javadocdir}/antlr \
  -Djaxp.javadoc=%{_javadocdir}/xml-commons-apis \
  -Dbeanutils.javadoc=%{_javadocdir}/jakarta-commons-beanutils \
  build.bindist

%install
%__rm -rf %{buildroot}

# jar
%__mkdir_p %{buildroot}%{_javadir}
%__cp -a target/dist/%{name}-%{version}/%{name}-%{version}.jar \
  %{buildroot}%{_javadir}
%__cp -a target/dist/%{name}-%{version}/%{name}-optional-%{version}.jar \
  %{buildroot}%{_javadir}
(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do %__ln_s ${jar} `echo $jar| %__sed "s|-%{version}||g"`; done)

# script
%__mkdir_p %{buildroot}%{_bindir}
%__cp -a %{SOURCE1} %{buildroot}%{_bindir}/%{name}

# dtds
%__mkdir_p %{buildroot}%{_datadir}/xml/%{name}
%__cp -a %{SOURCE2} %{buildroot}%{_datadir}/xml/%{name}/catalog
%__cp -a src/checkstyle/com/puppycrawl/tools/checkstyle/*.dtd \
  %{buildroot}%{_datadir}/xml/%{name}

# javadoc
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}
%__cp -ar target/dist/%{name}-%{version}/docs/api/* \
  %{buildroot}%{_javadocdir}/%{name}-%{version}
%__rm -rf target/dist/%{name}-%{version}/docs/api
%__ln_s %{_javadocdir}/%{name} target/dist/%{name}-%{version}/docs/api
%__ln_s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name} # ghost symlink

# demo
%__mkdir_p %{buildroot}%{_datadir}/%{name}
%__cp -ar target/dist/%{name}-%{version}/contrib/* \
  %{buildroot}%{_datadir}/%{name}

# ant.d
%__mkdir_p  %{buildroot}%{_sysconfdir}/ant.d
%__cat > %{buildroot}%{_sysconfdir}/ant.d/%{name} << EOF
checkstyle antlr regexp jakarta-commons-beanutils jakarta-commons-cli jakarta-commons-logging jakarta-commons-collections jaxp_parser_impl
EOF

%clean
%__rm -rf %{buildroot}

%post
# Note that we're using a fully versioned catalog, so this is always ok.
if [ -x %{_bindir}/install-catalog -a -d %{_sysconfdir}/sgml ]; then
  %{_bindir}/install-catalog --add \
    %{_sysconfdir}/sgml/%{name}-%{version}-%{release}.cat \
    %{_datadir}/xml/%{name}/catalog > /dev/null || :
fi

%postun
# Note that we're using a fully versioned catalog, so this is always ok.
if [ -x %{_bindir}/install-catalog -a -d %{_sysconfdir}/sgml ]; then
  %{_bindir}/install-catalog --remove \
    %{_sysconfdir}/sgml/%{name}-%{version}-%{release}.cat \
    %{_datadir}/xml/%{name}/catalog > /dev/null || :
fi

%post javadoc
%__rm -f %{_javadocdir}/%{name}
%__ln_s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ $1 -eq 0 ]; then
  %__rm -f %{_javadocdir}/%{name}
fi

%post optional
%__grep -q checkstyle-optional %{_sysconfdir}/ant.d/%{name} || \
%__perl -p -i -e 's|checkstyle|checkstyle checkstyle-optional|' %{_sysconfdir}/ant.d/%{name}

%postun optional
%__grep -q checkstyle-optional %{_sysconfdir}/ant.d/%{name} && \
%__perl -p -i -e 's|checkstyle-optional ||' %{_sysconfdir}/ant.d/%{name} || :

%files
%doc LICENSE LICENSE.apache README RIGHTS.antlr
%doc build.xml checkstyle_checks.xml java.header sun_checks.xml suppressions.xml

%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%{_datadir}/xml/%{name}
%attr(0755,root,root) %{_bindir}/*
%config(noreplace) %{_sysconfdir}/ant.d/%{name}

%files demo
%{_datadir}/%{name}

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%doc --no-dereference target/dist/%{name}-%{version}/docs/*

%files optional
%{_javadir}/%{name}-optional.jar
%{_javadir}/%{name}-optional-%{version}.jar

%changelog
* Thu May 17 2007 Igor Vlasenko <viy@altlinux.ru> 0:4.1-alt2_3jpp1.7
- converted from JPackage by jppimport script

* Sun Mar 26 2006 Vladimir Lettiev <crux@altlinux.ru> 4.1-alt2
- Fix build with j2se1.5

* Sun Dec 18 2005 Vladimir Lettiev <crux@altlinux.ru> 4.1-alt1
- Initial build for ALTLinux Sisyphus

%changelog
